#delimit ;
version 4.0;
*   Tutorial Definition file;
*   drop old definitions of steps if necessary;

* define the titles of steps in the tutorial;
capture program drop week1;
program define week1;

if "`1'"=="" {;
 stepdef 1 " Congratulations - You Made It Into the First Tutorial";
 stepdef 2 " Run Stata intro tutorial";
 stepdef 3 " Save, Replace, and Generate Commands";
 stepdef 4 " Generating Psuedo-Random Variables";
 stepdef 5 " Sums of two random variables:  graphical demonstration ";
 stepdef 6 " Practice with Mean and Variance ";
 exit;
 };
 if "`1'"=="doquiz" {; doquiz; exit; };
 loc t = "step`1'"; `t';
end;

* define each of the steps as a stata program ;
* and a quiz program if desired;
cap program drop step1;
program define step1;
  version 4.0; cap preserve;
  di in y
    "Tutor is a set of Stata programs that makes it easy to step" _n
    "through exercises with some instructions and comments as you go." _n
    "Each tutorial has several steps. Some steps will be simple.  For example"
    _n _col(20) in b "Step 25.  Run Stata intro.tut tutorial" _n(2) in y
    "Other steps will be pre-loaded Stata commands that illustrate a point." _n
    "These steps might ask you to run certain commands, predict results, etc" _n(2)
    "Whenever you are at Stata's prompt `.' you can go to different steps." _n(2);

  prompt " to see the commands tutor understands";
  help tutor;

  di "If you are running tutorial on a black and white screen and you" _n
     "have trouble seeing some of the text, try typing:" _n 
     ". set video bw" _n
     "before starting any tutorial.  To get color back, simply type" _n
     ". set video color";

  prompt "when ready to go on";
  refresh;
  di
     "In some weeks there will be a question based on the tutorial.  To see" _n
     "the quiz question, type " in w "quiz. " in y "and follow the instructions."
     _n(2) in g
     "Now go on to Step 2, by typing either " _n _col(15) in w  "goto 2" _n
     in g  "or" _n _col(15) in w  "next" _n;
*       ****************** end of step 1   ************ ;
end;

cap program drop step2;
program define step2;
version 4.0;   cap preserve;
  di in y "This step is also really easy.  Stata has a set of tutorials" _n
     "of its own (which of course aren't as good as these ;).  But they" _n
     "do show you the important commands for doing your work.  Here is " _n
     "a list of the tutorials that come with Stata and how to run them";
  prompt "when ready to see Stata tutorial index";
  tutorial;
  prompt "when ready to go on";
  di in y "Please run the following Stata tutorials: " in w "intro and graphics";
  di in y "Afterwards, you should understand these Stata commands: " _n
     _col(10) in w "use, descr, summ, tab, list, and graph";
  di in y "If you are using Student Stata, then the tutorials will not work";
  di in y "Instead, go through the sections of Statistics With Stata that" _n
          "cover these commands - the first couple chapters.";
  di in y "When finished with the Stata tutorials or SWS, go on to Step 3 ";
end;

cap program drop step3;
program define step3;
version 4.0; cap preserve;
     di in b
        in y  "In Step 2 you learned how to" _n
        in w   "use " in y " a data pre-made Stata data set" _n
        in w   "drop " in y "variables or observations " _n
        in w   "list " in y "values, and "
        in w "summarize " in y "variables." _n(2);
     di in y "There are four other important basic commands" _n
        _col(10) in w " save " _n
        _col(10)      " replace " _n
        _col(10)      " generate " _n
        _col(10)      " display ";
     di "Once you use a data set and then change it in some way, you " _n
        "will want to save the changes to disk.  To do this type" _n(2)
        _col(10) in w "save  <filename>" _n(2)
        in y "This will store the data into the file you specify with " _n
        in y "the extension " in w ".dta" in y ". Then you can " in w "use " _n
        in y "this data file later on " _n(2);
     di in w "replace " in y "lets you change values of variables in your data set " _n
        in y "for example if you had three variables " in w "x, y, and z " in y "you might" _n(2)
             _col(10) in w "replace x = 3*y + ln(z) if x >90" _n;
     di in y "This would look at each observation in your data set and " _n
             "x > 90 for the observation it would calculate 3*y + ln(z) " _n
             "for the observation and store the result back in x replacing " _n
             "and destroying whatever value was there before.  " _n(2);
     di in w "generate " in y "lets you create new variables.  For example " _n(2)
        in w _col(10) "gen v = exp(x - y^3)" _n(2)
        in y "creates a new variable v as a function of two other variables " _n
             "x and y ";
     prompt "when ready to go on";
     di in w "display " in y "is a very powerful command.  FOr now, you " _n
             "can think of it as a powerful " in w "calculator. " _n
        in y "It not only calculates but also allows you to add comments " _n
             "Here is an example of how to use display ";
     di _n(2);
     set trace on ;
     di 10/5 " " 100-5+3*2 " Hello " in b exp(1) " F(Z)=" normprob(1.96) " Bye " ;
     set trace off;
     di _n(2);
     di in y "Notice that display (or di) can evaluate expressions like 10/1" _n
             "it also understands all STata functions like " in w "exp and ln " _n
        in y "and functions like " in w "normprob " in y "which returns values " _n
             "of the standard normal distribution. ";
     prompt "When ready to see another example of display";         
     di _n(2);
     set trace on;
     macro define mn = 45.3;
     macro define sd = 31.5;
     di $mn "  The test statistic equals " $mn/$sd;
     set trace off;
     di _n(2) "The " in w "macro " in y "command "
             "lets you store single values (not a variable for each observation) " _n
             "Here I defined two values " in w "mn and sd " in y "which can be " _n
             "accessed in display by putting a dollar sign \$ in front of their " _n
             "names.  The dollar sign tells Stata that you want a macro variable " _n
             "and not a variable in your data set called mn";
     prompt "When ready to pause the tutorial and try display your self";
     pause "type q or end to return to the tutorial";
     di in y "Use the Stata help facilities or your Stata reference book " _n
             "(Statistics with Stata or Getting Started with Stata) " _n
             "for more information on these commands.";
     di in y "Now go on to Step 4";
end;

cap program drop step4;
program define step4;
version 4.0; cap preserve;
  di in y "One of the most powerful uses of computers for doing statistics " _n
     in y "is that computers can generate " in w "pseudo-random variables." in y "  A pseudo-random" _n
          "is not really random like the roll of a die.  The next random variable " _n
          "generated by a computer is computed using a formula, but that formula " _n
          "makes the sequence of numbers look like randomly drawn numbers .";
  prompt "when ready to go on ";
  di in y "To generate random variables in Stata, you use the " in w "uniform() " _n
     in y "function.  This function will return values that follow a uniform " _n
          "distribution between 0 and 1.  Using these pseudo-random uniform values " _n
          "and STata's other statistical functions, you can create pseudo-random " _n
          "variables from the " in w "normal " in y "distribution or any other " _n
          "distribution.";
  prompt "when ready to see how uniform works ";
  di in y "I am going to use display to show what uniform() does.  Here is "
          "a single pseudo random value: ";
  drop _all;
  set trace on ;
  di "Here comes a random value .... " in w uniform();
  di "Here comes four more random values: " in w uniform() " " uniform() " " uniform() " " uniform();
  set trace off;
  prompt "when ready to go on";
  di in y "Each time you use uniform() it returns a new a different value " _n
          "between 0 and 1 that is " in w "uncorrelated " in y "with the previous " _n
          "values.  In this way, uniform() draws what look like random variables.";
  di in y "You can also put pseudo-random values into variables in your data set";
  prompt "when ready to see how ";
  set trace on;
  set obs 10;
  gen u = uniform();
  gen uu = uniform();
  gen uuu = cond(uniform()>0.5,10,-10);
  gen n = exp(3);
  set trace off;
  di in y "These commands make the current data set have 10 observations " _n
          "and then generates four variables for each observation.  The" _n in w
          "cond " in y "function is like an if statement, it puts a 10 into uuu" _n
          "uniform() returns a value above 0.5 and a -10 otherwise";
  prompt "when ready to see a listing of u uu uuu";
  set trace on;
  list u uu uuu n;
  set trace off;
  di in y "Notice that each observation of u and uu have different values " _n
          "even though they were created with the same command. Compare that to " _n
          "n, which has the same value exp(3) for each observation. ";
  di _n(2) in w "Now go onto step 5 to see pseudo-random variables in action ";
end;

cap program drop step5;
program define step5;
   version 4.0; cap preserve;
   di in y
   "In this step we use Stata to demonstrate theoretical"_n
   "results concerning the sum of two random variables." _n
   in b
    "Let " in w "X"  in b "and " in w "Y " in b
    "be ANY two random variables.  Then "
    _n    _col(15)
    "1. " in w "E(X+Y) = E(X) + E(Y)" _n    _col(15) in b
    "2. " in w "Var(aX+bY) = a*a Var(X) + b*b Var(Y) + 2abCov(X,Y)" _n(2) _col(10) in b
    "Furthermore:" _n(2) _col(15)
    "3. " in w "If X and Y are normally distributed, then X+Y is also normal." _n _col(15) in b
    "4. " in w "If X and Y are NOT normal, then X+Y may have a completely" _n _col(15)
    "   different distribution than X or Y." _n(3) in b;
prompt "when ready to go on";
refresh;
   di in y
"To demonstrate these results, I'm going to create 4 " in w "psuedo random variables" _n in y
"using the random number generator that you just learned about." _n
"Stata will echo the commands I'm going to run.";
prompt "when ready to go on ";
         di _n(2);
         drop _all;
         set obs 140;
         qui set trace on;
         generate U1 = uniform();
         generate U2 = uniform();
         generate N1 = -3*invnorm(uniform())+6;
         generate N2 = 2*invnorm(uniform()) - 12;
         summ;
         set trace off;
   di _n(2) in y "Look at the four" in w " generate " in y "commands above." _n
in y "U1 and U2 are drawn from the UNIFORM distribution as in Step 4" _n
     "N1 and N2 are from two different NORMAL distributions. That is," _n(2)
    _s(15) in w  "N1 ~ N(6,9) " _n
    _s(15)     "N2 ~ N(-12,4)" _n(2) in y
"The combination of functions " in w "invnorm(uniform()) " in y "draws standard normal" _n
"variables N(0,1). The generate statment adds and multiplies constants so that" _n
"N1 and N2 have means of 6 and -12 and variances of 9 and 4, respectively." _n(2);
   inprompt "Do you want to see the first 50 values of each variable (y/n)";
   if "$junk"=="y" | "$junk"=="Y" {;
         di _n(2);
         qui set trace on;
         list U1 U2 N1 N2 in 1/50;
         qui set trace off;
         prompt "to continue";
         };
   refresh;
   summ;
   di _n(2) in b
"Question:  Do the standard deviations of N1 and N2 make sense given " _n
"their theoretical Variances of 9 and 4?";
   prompt "after deciding";
   refresh;
  di
"To verify that the pseduo-random variables N1 is approximately normal," _n
"I'm going to draw a histogram for N1. When you are done looking at the" _n
"graph type ANY KEY to continue.";
prompt "when you are ready";
              qui set trace on;
              graph N1, hist bin(15) normal
                  title(Distribution of Normally Distributed Random Numbers);
              qui set trace off;
   di _n
"Notice that the histogram of N1 was similar to the bell-shaped normal density" _n
"draw with the histogram.";
di "Also, notice that the " in w "hist " in y "option for " in w "graph " in y
   "draws a histogram ";
  prompt "to stop the tutorial to make more graphs yourself";
  pause $sname: type q or end at the . to resume the tutorial;
  refresh;
  summ;
   di _n(2) "Above are summary statistics for our 4 random variables:";
   inprompt "What is the MEAN or EXPECTED VALUE of U1+U2";
   local mn1 = "$junk";
   inprompt "What is the VARIANCE of N1+N2";
   local sd2 = "$junk";
   di in y
   "Watch the Stata commands used to generate U1+U2 and N1+N2:";
          qui set trace on;
          gen sum_u = U1 + U2;
          gen sum_n = N1 + N2;
          qui set trace off;
          qui summ sum_u;
          local ans1 = _result(3);
          qui summ sum_n;
          local ans2 = _result(4);
          qui set trace on;
          summ sum_u sum_n;
          qui set trace off;
   di _n in g
   "You're guess for the Mean " _col(35) "`mn1'" _n
    " and the actual value " _col(35) `ans1' _n(2)
   "You're guess for the Variance " _col(35) "`sd2'" _n
   " and the actual value " _col(35) `ans2' " = " sqrt(`ans2') "*" sqrt(`ans2') _n(2);
   prompt "when ready to go on";
   refresh;
   di in y
   "What do you think the distributions of sum_u and sum_n look like?" _n;
   prompt "to stop tutorial to graph sum_u and sum_u";
   pause $sname type q or end to return to the tutorial;
   refresh;
   di _n(2)
   "Notice that the sum of the two normal random variables is close to" _n
   "normal itself.  It's not exactly normal because we only have 140" _n
   "observations from the distribution, not the whole distribution." _n(2)
   in b
   "What do you think sum_u's histogram will look like?";
   prompt "to stop the tutorial to create histograms yourself";
   pause $sname type q or end to return to the tutorial;
   di _n(2)
   "The distribution of sum_u  is not very uniform." _n
   "In fact, it looks somewhat like the normal distribution.  Why?";
   prompt "when you are ready for a summary of Step 5";
   refresh;
   di in y
   "Each of these results have been demonstrated" _n(2)
in b
    "Let X and Y be ANY two random variables.  Then"
    _n    _col(15)
    "1. E(X+Y) = E(X) + E(Y)" _n    _col(15)
    "2. Var(aX+bY) = a*a Var(X) + b*b Var(Y) + 2abCov(X,Y)" _n(2) _col(10)
    "Furthermore:" _n(2) _col(15)
    "3. If X and Y are normally distributed, then X+Y is also normal." _n _col(15)
    "4. If X and Y are NOT normal, then X+Y may have a completely" _n _col(15)
    "   different distribution than X or Y." _n(3);
   di _n(2)
   "You can go on to step 6, or you come back to it some other time." _n
   "To leave Stata type " in w "exit,clear";
end;

cap program drop step6;
program define step6;
  version 4.0;  set trace off;  cap preserve;
  di in b "When answering these questions your answers can be expressions" _n
          "like " in w "6/12 " in b "or " in w "0.1*(3+0.2*4)." in b " Stata will " _n
          " calculate your expression and check it against the correct value." _n(2)
          "If you want to square some quantity, use ^2.  Example:" in w _n
          " (4-1)^2 = 3^2 = 3*3 = 9" _n(2)
     in b
"Also, Stata sometimes will write a number like 1.2 as 1.1999999999999." _n
"Just treat it as 1.2.  You can round off numbers to 3 decimal places." _n(2);
  prompt "when ready to go on";
  local goon = "y";
  while "`goon'"=="y" | "`goon'"=="Y" {;
        xdist y y y;
        inprompt "Do you want to do another example (y/n)?";
        local goon = "$junk";
        };
 di in y  "That ends the last step in the tutorial." _n
            "To see the quiz question type " in w "quiz" _n in y
            "To leave Stata type " in w "exit,clear" _n
       in y "To go back to other steps use " in w "goto";

end;

* define quiz if desired;
program define doquiz;
  version 4.0;  set trace off; cap preserve;
  di in w "Instructions" _n in y
"Here is the density (probability) function for a random variable called X. " _n
"X takes on the three values at the top of the table with the probabilities " _n
"given inside the table"_n(2);
 local x1 = round(4*uniform(),1);
 local x2 = round(`x1'+1+(7-`x1'-1)*uniform(),1);
 local x3 = round(`x2'+1+(9-`x2'-1)*uniform(),1);
 local fx1 = round(0.1 + 0.4*uniform(),0.10);
 local fx2 = round(0.8*(1-`fx1')*uniform(),0.10);
 local fx3 = round((1-`fx1'-`fx2'),0.10);
 local mnx = round(`x1'*`fx1' + `x2'*`fx2' + `x3'*`fx3',0.000001);
  di in y _n
 "Write down the numbers in the table in case " _n
 "the table scrolls off the screen.";
  prompt " to see the table";
  xtable `x1' `x2' `x3' `fx1' `fx2' `fx3';
*  di "Given the information that E(X) = `mnx', " _n
         in r  "Calculate Var(X). " _n
         in y  "Note:  this is the population variance not sample variance";
  di in w _col(10) "What is P(X=`x3'|X>=`x2')???" _n _col(10) "Submit your answer on the sheet";
end;
