#delimit ;

program define week2;
version 4.0;
if "`1'"=="" {;
  stepdef 1 "Using Statistical Tables - Normal Distribution";
  stepdef 2 "Using Statistical Tables - t Distribution";
  stepdef 3 "Using Stata Commands Instead of Statistical Tables";
  stepdef 4 "Demonstrating the Central Limit Theorem";
  stepdef 5 "Practice with Joint, Marginal, and Conditional Densities";
  exit;
  };
 if "`1'"=="doquiz" {; doquiz; exit; };
 loc t = "step`1'"; `t';

end;

program define step1;
  version 3.0;  set trace off;  cap preserve;
di in y "To conduct tests of hypotheses or to contruct confidence intervals" _n
     "it is necessary to calculate values of the cumulative distribution function" _n
     "for the " in w  "normal, t, or chi-squared distributions." _n(2)
in y "There is one catch:  the distribution functions for these types of random" _n
     "variables do not have explict formulas.  ";
prompt "when ready to go on";
di in y "In the old days, someone would spend years numerically calculating " _n
        "tables of values by hand to be published and used by others.  The back " _n
 "of text books contain several of these tables, and you used these tables" _n
 "in your statistics class." _n;
di in w "Welcome to the modern version of a statistic table";
prompt "when ready to see the normal table";
ztable;
di in y "That table was created using the " in b "tutor " in y "command " in w "ztable"; 
di in y
 "You can use a statistical table to calculate two different types of values:" _n
   _n(2) _col(5) in g
     "A. Value of a cumulative distn at a realization of the random variable " 
   _n(2)  "OR" _n(2)
  _col(5)
     "B. Value of realization associated with a value of the cumulative" _n _col(8)
         "distribution." _n;
  di in y "In symbols, let F(x) be the cumulative distribution function" _n
            "(normal,t,or chi-sq). You can solve for " in w "y" in y
            "given " in w "z " in y "such that:"
   _n(2) _col(5) in g
     "A.  y = F(z)"
   _n "OR" _n(2) _col(5)
     "B.  F(y) = z" _n;
di in y
 "Let's review your memory of these skills.  I want you to look up some" _n
 "values using ztable.  Let " _n
            in w "Z ~ N(0,1)," _n
 in y " which means Z is a random variable" _n
 "that follows the standard normal distribution (mean 0 and variance 1)." _n(2);
 ansent 0.4929 "The probability that 0 < Z < 2.45";
 di in y "Ok, hopefully that wasn't too hard.  Try this one:" _n;
 local ans = 0.5-0.2291;
 ansent `ans' "The probability that 0 < Z < 0.61";
  di
  in y "Here's a final one that might require some figuring on your part" _n
       "Recall that if "
       in w "X "
       in y "is normally distributed, then "
       in w
       "Y = aX + b " in y "is also normally" _n
    "distributed but Y has a different mean and variance than X." _n
    "To look up the values of the cumulative distribution of Y in the table," _n
    "you must convert the values to those for the standard normal Z" _n
    "In other words, if " in w "Z ~ N(0,1) and Y = 3Z + 5 " in y " then ";
  di in w
       _col(10)
  "Prob(Y < 5) = Prob(3Z + 5 < 5)" _n _col(10)
  "            = Prob( 3Z < 0)" _n _col(10)
  "            = Prob(Z < 0)" _n _col(10)
  "            =      0.5" _n(2)
  in y "So suppose " in w "Y = 2Z - 6. " _n in b; 
  local ans = round(0.5+.3413,0.01);
  ansent `ans'  "What is the probability that Y < -4";
  inprompt "Do you want an explanation of the answer (y/n)";
  if "$junk"=="y" | "$junk"=="Y" {;
     refresh;
    di in y
   "The key is to transform the probability value concerning Y into a" _n
   "probability value concerning Z by using simple algebra:" _n
   in w _col(10)
    "Prob(Y < -4) = Prob(2Z - 6 < -4)" in g _col(60) "defn of Y" _n _col(5) in w
    "             = Prob( Z < 1 )    " in g _col(60) "solving for Z" in w _n _col(5)
    "             = Prob( Z < 0 ) + Prob( 0 < Z < 1 ) " in g _col(60) "break up Prob" in w _n _col(5)
    "             =    0.5        + Prob( 0 < Z < 1 ) " in g _col(60) "symmetry of Z distn" in w _n _col(5)
    "             =    0.5        +      0.3413       " in g _col(60) "value in table" in w _n _col(5)
    "             =    0.83413  " in g _col(60) "addition" _n(2);
    };
  di in r _n(3)
 "Go to step 2 to practice using the table for the t-distribution";
end;

program define step2;
  version 3.0;  set trace off;  cap preserve;
  di _n(3)
in y "Just as THE normal distribution actually refers to many related" _n
   "distributions with different means and variances, THE t-distribution" _n
   "and THE chi-square distribution refer to many distributions that depend" _n
   "on one parameter, called the the degree(s) of freedom." _n(2)
   "Recall their definitions:  Let Z1, Z2, ..., Zk be INDEPENDENT, STANDARD" _n
   "NORMAL random variables.    Then the quantity:" _n
in w _col(10)
   "Y = Z1*Z1 + Z2*Z2 + ... + Zk*Zk";
di in y
   "is said to follow the chi-square distribution with k degrees of freedom."
_n(2) "And let Z be a STANDARD NORMAL random variable, and let " _n
   "Y be a CHI-SQUARE random variable with k degrees of freedom.  Then" _n
in w _col(10)
   "            Z       " _n _col(10)
   "t   =     -----     " _n _col(10)
   "               0.5  " _n _col(10)
   "          (Y/k)     " _n
in y "is said to follow the " in w "t distribution with k degrees of freedom." _n;
prompt "when ready to see a t table ";
ttable;
di in y "That table of t values was created using the tutor command " in w "ttable ";
di in y _n(2) 
  "Let degrees of freedom k = 15. Use ttable answer 3 questions:" _n;
  ansent 0.025 "1. The probability that  t > 2.131";
  ansent 3.733 "2. The value of t such P( |t| > 0.002) (15 df)";
  ansent -0.49 "3. P( t > 2.602) - P( |t| > 0.0691) (15 df)";
  refresh;
  di in y "It might take a while to figure out how to use the table";
  inprompt "Do you want to try some 2 more examples (y/n)?";
  local goon = "$junk";
  while "`goon'"=="y" | "`goon'"=="Y" {;
    refresh;
    macro define df1 = round(200*uniform(),1)+1;
    macro define df2 = round(200*uniform(),1)+1;
    macro define inv1 = cond(uniform()>0.5,0.05,0.10);
    macro define inv2 = round(invt($df2,1-cond(uniform()>0.5,.01,.20)/2),0.01);
    macro define ans1 = round(invt($df1,1-$inv1),0.001);
    macro define ans2 = round(tprob($df2,$inv2)/2,0.01);
    ansent $ans2 "P(t < -$inv2) ($df2 df)";
    ansent $ans1 "The value of y such that P(|t| > y) = $inv1 ($df1 df)";
    inprompt "Do you want to try 2 more examples (y/n)?";
    local goon = "$junk";
     };
  di in y
  "Go to step 3 to learn how to use Stata directly instead of ttable and ztable"; 
end;

program define step3;
  version 3.0;  set trace off;  cap preserve;
   di in y
   "Steps 2 and 3 reviewed the old way to calculate (i.e. lookup) values" _n
   "of cumulative distribution functions for which no explict formula exists." _n(2)
   "The two ways to use the table are (in symbols):" _n
   _n _col(5) in g
     "A.  y = F(z)   or"
   _n _col(5)
     "B.  F(y) = z" _n(2);
   di in y
   "In other words, you can use the tables to evaluate the function or" _n
   "to evaluate the " in w "inverse " in y "of the function." _n;
di in y  "An alternative is to use one of four functions in Stata:" _n
   _col(10) in w "normprob(z)  tprob(df,t) "_n
   _col(10)      "invnorm(p)   invt(df,p)   " _n
   in y "The " in w "prob " in y "functions perform task A" _n
        "The " in w "inv  " in y "functions perform task B";
   di in y
   "For example, let Z ~ N(0,1).  To calculate P( Z < -1 ):" _n;
   set trace on;
   display "The answer is: " normprob(-1);
   set trace off;
   di in y _n(2)
   "Suppose " in w "Y = 2Z." in y "What is " in w "P(Y > 0.8):";
   set trace on;
   di "Another type A operation: " 1-normprob(0.8/2);
   set trace off;
   inprompt "Do you want an explanation of the answer (y/n)";
   if "$junk"=="y" | "$junk"=="Y" {;
      di in y
   in w _col(10)
    "Prob(Y > 0.8) = Prob(2Z > 0.8)" _n _col(10)
    "             = Prob( Z > 0.4 )    " _n _col(10)
    "             = 1 - Prob( Z < 0.4 ) " _n _col(10)
    "             = 1 - normprob(0.4)     ";
   prompt "When ready to go on";
    };
   di in y
   "Use invnorm() to do B.  If you need to know " in w "z such that P(z < 0.05):";
   set trace on;
   display "Type B operation: " invnorm(0.05);
   set trace off;
   refresh;
   di in w
   "tprob " in y " automatically calculates probability of BOTH tails of t:" _n _col(10)
   in w  "tprob(k,x) = Prob( |t| > x ) " in y "   with k degrees of freedom";
   di in y "First, use ttable to calculate:" _n;
   macro define ans1 = round(invt(30,1-0.02),.001);
   ansent $ans1 "Value of x such that Prob(|t|>x) = 0.02 (df = 30)";
   di in y "Here's how to do the same thing in Stata:";
   set trace on;
   display "B-type operation with the t distribution " invt(30,1-0.02);
   set trace off;
   di in y
      "Notice that " in w "invt " in y " wants you to provide "
      in w " 1 - prob. " in y "of both tails!" _n
  in y "This is definitely confusing. (I still get confused by it!)  But " _n
     "with some practice you can figure out how to use invt and tprob." _n(2)
     "The " in w "display " in y " command is a SUPER-calculator in Stata" _n
      "(In fact, display is used to print out these instructions in living colour!)" _n
      in y "Type " in w "help display " in y "for more information";
  di in y "Type " in w "help functions " in y "for help on functions like normprob" _n(3)
     in r "Go on to step 5 to see the Central Limit Theorem in action";
end;

program define step11;
  version 3.0;  set trace off;  cap preserve;
  quietly {;
  drop _all;
  set obs $n;
  gen u = uniform();
  summ u;
  macro define mnn = _result(3);
  drop _all;
  set obs 1;
  gen x = $mnn;
  };
end;

program define step4;
  version 3.0;  set trace off;  cap preserve;
   di _s(10) in b "Demonstrating the Central Limit Theorem"_n(3);
   di "Here is a restatement of the CLT"
   _n _col(10) in b
         "Let X1, X2, ..., Xn denote n independent random variables with"
   _n _col(10)
         "the same PDF with mean = m and variance s*s.  Let "
_n _col(15) "  _      N        "
_n _col(15) "  X  =  SUM  Xi/n "
_n _col(15) "        i=1       "
      _n _col(10) "       _   "
      _n _col(10) "Then   X  ~ N(m,s*s/n)"
      _n _col(10) "    n->inf";
prompt "When ready to continue";
refresh;
   di in y
   "To demonstrate the CLT result we will use Stata to do the following:" _n in g
_col(10) "1.  Draw n=5 observations from the UNIFORM distribution" _n
_col(10) "2.  Calculate the mean of the n=5 observations, record the mean" _n
_col(10) "3.  Draw another n=5 observations, record the mean again" _n
_col(10) "4.  Do steps 1-3 75 times (replications), then read in the 75 means" _n
_col(10) "5.  Graph the distribution of the means against the normal." _n
_col(10) "6.  Let you set n and the number of replications " _n(2);
  di in y "The density function for the uniform distribution is " _n
     in w _col(10)  "f(u) = 1  for 0 <= u <= 1 " _n
     in w _col(10)  "     = 0  otherwise " _n(2)
     in y "It is EASY to show E[U] = 0.5, and not TOO hard to show Var(U) = 1/12. " _n
          "The mean of sample means of n draws of U is 0.5 and the " _n
          "variance of sample means is 1/(12*n).  Our artificial sample " _n
          "of 75 means may not be very close to a normal distribution," _n
          "because n=5 is not very close to infinity.  However, we know " _n
          "that the variance should be 1/(12*5))." _n(3)
          "Why 1/(12*5) and not 1/(12*75)?  Because n is the size of the" _n
          "sample of original random variables, which I set at n=5.  The" _n
          "number 75 is how many samples we are going to draw artificially.";
  prompt "When ready to run the experiment";
  refresh;
  di in y "Watch the following Stata commands:";
  quietly {;
  drop _all;
  cap erase clt_tmp.dta;
  macro define n = 5;
  local m = 75;    };
  if $logon==1 {;
     di in r "The screen log file is temporarily turned off";
     qui cap log close;  };
  while $n != -1{;
        di in y
          "Here are the observations in the first artificial data sample:";
        set trace on;
        set obs $n;
        gen u = uniform();
        list u;
        summ u;
        set trace off;
        macro define mnn = _result(3);
        quietly cap log using __tmp, replace;
        di $mnn;
        quietly log close;
        drop _all;
        di in y
        "These commands calculated and stored one mean for sample size $n" _n
        "For the rest of the samples I'll only show you the computed mean" _n;
        prompt "When ready to continue with the experiment";
        local i = 2;
        set more 1;
        while `i' <= `m' {;
           step11;
           di in g "(sample size $n) Mean of Sample Number `i' = " _c;
           local i = `i'+1;
           quietly cap log using __tmp, append;
           di %8.5f $mnn;
           quietly log close;
           drop _all;
           };
        set more 0;
        beep;
        di in y "The experiment is complete";
        prompt "When ready to see the results";
        refresh;
        cap infile mns using __tmp.log;
        di in y "First we'll graph the histogram of sample means";
        prompt;
        graph mns, bin(25) normal
              t1("Distn of Sample Mean of Uniform Random Variables")
              t2("sample size=$n, number of replications = `m'")
              xlabel(0.3, 0.4, 0.5, 0.6, 0.7)
              l1(Fraction of Sample Means);
        di in y "How close was the distribution to Normal?" _n
                 "How large should n be to get close?";
        prompt "When ready to continue";
        di in y
        "Now let's confirm the mean and variance (or st.dev.) of the " _n
        "distribution of sample means:";
        summ mns;
        local sd = sqrt(_result(4));
        di in b "Why does the standard deviation equal " %8.5f `sd' "?";
        prompt "When ready to continue";
        cap erase clt_tmp.log;
        cap rm clt_tmp.log;
        drop _all;
        refresh;
        inprompt "Do you want to try again with another sample size (y/n)?";
        if "$junk"=="y" | "$junk"=="Y" {;
           di in r "If you are using " in w "Student Stata " in r
                   " set the next two values below 160" _n;
           inprompt "Enter a sample size of 2 or more";
           macro define n = $junk;
           inprompt "Enter the number of means to simulate (was 75 first time)";
           local m = $junk;
           };
        else {;
             macro define n = -1;
             };
        };
   di _s(10) in b "Do your own Experiment" _n(3)
   in y "If you want to run your own experiments to demonstrate the CLT," _n
        "read pp. 176-177 in SWS.";
  if $logon==1 {;
     di in r "The screen log file is turned back on";
     qui cap log using screen.log, append;};
end;

program define step12;
  di _col(10) in g
      "                     X                         " _n _col(10)
      "          1          2          3              " _n _col(10)
      "        ---------------------------            " _n _col(10)
      "     0   `1'   |   `2'    |  `3'     `7'       " _n _col(10)
      " Y      -------+----------+--------            " _n _col(10)
      "     1   `4'   |   `5'    |  `6'     `8'       " _n _col(10)
      "        -------+----------+--------            " _n _col(10)
      "         `9'       `10'      `11'              " _n(2);
end;

program define step5;
  version 3.0;  set trace off;  cap preserve;
  di in b "When answering these questions your answers can be expressions" _n
          "like " in w "6/12 " in b "or " in w "0.1*(3+0.2*4)." in b " Stata will " _n
          " calculate your expression and check it against the correct value." _n(2)
          "If you want to square some quantity, use ^2.  Example:" in w _n
          " (4-1)^2 = 3^2 = 3*3 = 9" _n(2)
in b
"Stata sometimes writes a number like 1.2 as 1.1999999999999." _n
"Treat it as 1.2.  You can round off numbers to 3 decimal places." _n(2)
"However, Stata has a limit of 80 characters you can type" _n
"in interactively.  So in long expressions you should simplify." _n
"Type " in w ".5 " in y "(2 characters) instead of " in w "1-0.5 " in y "(5 characters)"
_n(2);
  prompt "when ready to go on";
  xydist "y" "y" "y";
   di in r  "That's ends the last step in the tutorial." _n
   "To leave Stata type " in w "exit,clear" _n
   in r "Or go back to other steps using " in w "goto";
end;

