#delimit ;

program define week8;
version 4.0;
if "`1'"=="" {;

stepdef 1 "Formulating Simultaneous Hypothesis Tests";
stepdef 2  "The Suggested Regression Model";
stepdef 3  "Suggested Hypothesis Tests";
stepdef 4  "Performing the Tests";

  exit;
  };
 if "`1'"=="doquiz" {; doquiz; exit; };
 loc t = "step`1'"; `t';

end;

program define step6;
  version 3.0;
  drop _all;
  cap use student1;
  cap use c:/stata/student1;
  cap use c:/stustata/student1;
  cap use d:/stustata/student1;
  if _N < 100 {;
    refresh;
    di in r "I'm sorry.  I can't locate " in w "student1.dta " in r "on this " _n
            "computer.  I've looked in the following directories: "
            _n _col(10) in w
            "c:/stata" _n _col(10)
            "c:/stustata" _n _col(10)
            "d:/stustata" _n _col(10);
    inprompt "enter the path to where the directory city.dta is located (eg. c:/mydata)";
    loc pth = "$junk"+"/student1";
    cap use `pth';
    if _N < 109 {; di in r "Still can't find it - exiting tutorial"; exit; };
    };
  quietly {;
  keep year age major gpa study athlete employed allnight ditch sex;
  drop if gpa==.;
  drop if ditch==.;
  drop if study==.;
  recode ditch 1=0 2=1 3=2 4=3;
  recode ditch 5=4.5 6=7 7=10 8=13;
  label values ditch;
  replace employed = 2-employed;
  label de emp 0 "No" 1 "Yes";
  label values employed emp;
  rename sex male;
  recode allnight 1=0 2/4=1;
  label de all 0 "Never" 1 "Some-V.Freq.";
  label values allnight all;
  replace athlete = 2-athlete;
  label values athlete emp;
  macro define N = _N;
  };
end;

program define step5;
  version 3.0;
  di in b "The hypotheses are: ";
  di _n in w "1." in b
     "  Not all reasons for missing class are the same.  In particular, " _n
     "    the effect of ditching class on gpa is different for students that are " _n
     "    employed than for students who are unemployed.  Under H0, employment " _n
     "    status has no direct effect on gpa and employment status does not " _n
     "    alter the effect of ditching on grades.  Under the alternative, "   _n
     "    employment has a direct effect (positive or negative) on gpa, and " _n
     "    it alters the effect ditching has on gpa (perhaps raising or lowering it).";
  di _n in w "2." in b
     "  Not all studying is the same.  In particular, the relationship between " _n
     "    gpa and study time differs for students who tend to study all night" _n
     "    than for those who don't study all night.  Under H0, studying allnight " _n
     "    has no direct effect on gpa.  And allnight studying doesn't change " _n
     "    the relationship between study time and gpa.  Under HA, studying all " _n
     "    night has a direct effect (positive or negative) on gpa, and " _n
     "    it alters the effect of study time on gpa (perhaps raising or lowering it).";
  di _n in r
     " You're job is to test these two hypotheses using one multiple regression" _n
     " while controlling for at least age and sex of the student as well.  (You can " _n
     " control for other factors too if you wish.)  ";
end;

program define step1;
  version 3.0;  set trace off;
  di in y
    "In this tutorial one of the sample data sets will be loaded" _n
    "and cleaned up for you (variables redefined, unnecessary variables " _n
    "dropped, etc).  You will be shown summary statistics of the data, and " _n
    "then asked to pose two questions about the data.  You are then told to" _n
    in w _col(5)
    "1. Develop a mulitple regression model for the data" _n _col(5)
    "2. Form hypotheses about the model that pose the verbal questions " _n _col(5)
    "3. Test the hypotheses.  " _n;
    di in y "After each step you will be given a " in w "suggested answer." in y _n
    "for that part. The correct way to approach the problem is not unique. " _n
    "There are " in w "incorrect " in y "approaches, however.";
  prompt "when ready to continue";
  refresh;
  di in y "The data come from a survey of students in a sociology class." _n
          "You are asked to study what determines the g.p.a. (grade point " _n
          "average) of a student.  (Note: a gpa of 4.0 means A's" _n
          "in all classes.)  In particular, we are interested in understanding" _n
          "how student behaviour helps determine gpa.  The two types of behavior" _n
          "we will focus on are: going to class and study habits.  We also " _n
          "want to control for differences between sexes and ages";
  di in y _n "The data will now be loaded and processed";
  prompt "when ready to continue";
  refresh;
  step6;
  describe;
  di in b "Look through the variable definitions and labels" _n(3);
  prompt "when ready to see summaries and tabulations";
  summ;
  more;
  tab employed;
  tab ditch;
  prompt "when ready to see some graphs";
  graph gpa study;
  graph gp ditch;
  sort allnight;
  graph gpa study, by(allnight);
  refresh;
  di in y "You are asked to consider the following two hypotheses.  They "_n
          "should be tested separately, but each requires an F-test rather " _n
          "than only a t-test.  " _n;
  prompt "when ready to go on" ;
  step5;
  prompt "when ready to continue";
  refresh;
  di in y
  "Here is a regression that is NOT complex enough to test 1 and 2" _n(3);
  prompt "when ready";
  regress gpa  age employed study ditch male allnight;
  di _n in y "Here we see that gpa seems to be related positively" _n
             "to study time and age but not strongly related to employment, " _n
             "ditching, or allnight studying.  ";
  di _n in y "But we cannot test 1 and 2 with this regression, because " _n
             "it imposes the restriction that ditching and studying have " _n
             "the same effect for all students.  Both 1 and 2 asked about " _n
             "differences in their effects on gpa depending upon other factors";
  prompt "when ready to continue";
  di _n in b "You're first task is to develop a regression model that is " _n
             "complex enough to test both 1 and 2, and then to pose 1 and " _n
             "2 as linear hypotheses test that can be tested using the " _n
             "F test talked about in class.  Do this on paper before" _n
             "proceeding to step2.  Step 2 will give you a suggested answer.";
  di in y
  "To see the hypotheses again, type " in w "goto 5" in y ". The data" _n
  "will remain loaded for you to look at.  If something goes wrong and you " _n
  "want to reload the original data, type  " in w "goto 6" in y ".";
end;

program define step2;
 version 3.0; set trace off;
  di in w _col(10)
  " GPA  =   b1*1 + b2*AGE + b3*MALE " _n _col(10)
  "        + b4*EMPLOYED + b5*DITCH  + b6*EMPLOYED*DITCH  " _n _col(10)
  "        + b7*ALLNIGHT + b8*STUDY  + b9*STUDY*ALLNIGHT " _n _col(10)
  "        + u ";
  di in y
  "The key are the interaction terms between DITCH and EMPLOYED and " _n
  "between STUDY and ALLNIGHT.  These features allow the marginal effect of " _n
  "ditching and studying on gpa to differ from employed students and for " _n
  "students who cram.";
  di in y
  "This model is the barebones necessary to test 1 and 2.  You can also" _n
  "control for other variables, use logs, perhaps put in STUDY*STUDY " _n
  "to allow for decreasing returns to studying, and so forth." _n;
  di "Using this model or your model, form the null and alternative " _n
     "hypotheses that test 1 and 2.  Determine the distribution of the " _n
     "the test statistic under the null. Go to step 3 for a suggested answer.";
end;

program define step3;
  version 3.0;  set trace off;
  di in w
  " GPA  =   b1*1 + b2*AGE + b3*MALE " _n _col(10)
  "        + b4*EMPLOYED + b5*DITCH  + b6*EMPLOYED*DITCH " _n _col(10)
  "        + b7*ALLNIGHT + b8*STUDY  + b9*STUDY*ALLNIGHT " _n _col(10)
  "        + u " _n;
  di in w _col(10)
  "  1:   H0:  b4 = 0 and  b6 = 0 " _n _col(10)
  "       HA:  b4 <> 0 and  b6 <> 0" _n _col(10)
  "  2:   H0:  b7 = 0 and  b9 = 0 " _n _col(10)
  "       HA:  b7 <> 0 and  b9 <> 0";
  di in b "In both cases, the test statistic is F(2,$N-9) distributed under H0" _n(2);
  di in y _n(2)
  "Notice that under H0 in 1 EMPLOYED has no effect on expected GPA.  Under " _n
  "HA, however, the marginal effect on gpa of another class ditched is " _n
  " b5 + b6 for the employed.  For the unemployed the effect is only b5. " _n
  "If b5 < 0, then ditching hurts expected gpa for unemployed.  If b6 > 0 " _n
  "but b5+ b6 < 0, then ditching hurts the employed but not as much." _n;
  di in y "Hyp. 2 has the same sort of interpretation.";
  di in b "WRITE down the RESTRICTED forms of the model that correspond to " _n
          "H0 under 1 and H0 under 2.";
  prompt "when ready to see the answer";
  di in r "Unrestricted Model" _n in w _col(10)
  " GPA  =   b1*1 + b2*AGE + b3*MALE " _n _col(10)
  "        + b4*EMPLOYED + b5*DITCH  + b6*EMPLOYED*DITCH " _n _col(10)
  "        + b7*ALLNIGHT + b8*STUDY  + b9*STUDY*ALLNIGHT " _n _col(10)
  "        + u " _n;
  di in r "Restricted Model in 1" _n in w _col(10)
  " GPA  =   b1*1 + b2*AGE    + b3*MALE " _n _col(10)
  "        +        b5*DITCH  +  " _n _col(10)
  "        + b7*ALLNIGHT + b8*STUDY  + b9*STUDY*ALLNIGHT " _n _col(10)
  "        + u " _n;

  di in r "Restricted Model in 2" _n in w _col(10)
  " GPA  =   b1*1 + b2*AGE + b3*MALE " _n _col(10)
  "        + b4*EMPLOYED + b5*DITCH  + b6*EMPLOYED*DITCH " _n _col(10)
  "        + b8*STUDY  " _n _col(10)
  "        + u " _n;
  prompt "when ready to continue";
  di in y "Generate the variables and run the regression necessary to " _n
          "to estimate the model.  Then use test to test the null " _n
          "hypotheses.  Make your decision to reject both H0's or not.  Then" _n
          "go to step 4 to see suggested procedure, results and interpretation.";
end;

program define step4;
  version 3.0;  set trace off;
  step6;
  set trace on;
  gen empdtch = employed * ditch;
  gen allstdy = allnight * study;
  regress gpa age male employed ditch empdtch allnight study allstdy;
  macro define RSSUR = round(_result(4),0.0001);
  set trace off;
  prompt "when ready to ready test 1 and 2";
  set trace on;
  test employed = 0, notest;
  test empdtch = 0, accum;
  macro define F1 = _result(6);
  set trace off;
  more;
  di in y
  "The p-value indicates that H0 should be rejected by any researcher " _n
  "using a significance level of " fprob(_result(3),_result(5),_result(6)) " or higher. ";
  prompt "when ready to go on";
  refresh;
  di in b "Let's verify that test is working properly:";
  di in y "The test command computed an F statistic equal to " $F1;
  di in y "The RSS from the Unrestricted model equals " $RSSUR;
  di in y "The Restricted model is (make note of RSS!):";
  more;
  set trace on;
  regress gpa age male ditch allnight study allstdy;
  set trace off;
  macro define RSSR = round(_result(4),0.0001);

  di _n(2)
  "The value of the F statistic should therefore equal " _n in w _col(10)
  "F = (($RSSR-$RSSUR)/2) / ($RSSUR/ ($N-9)) = "
     (($RSSR-$RSSUR)/2)/($RSSUR/($N-9));
  prompt "when ready to Test Hypothesis 2";
  refresh;
  set trace on;
  regress gpa age male employed ditch empdtch allnight study allstdy;
  test allnight=0, notest;
  test allstdy=0, accum;
  set trace off;
  di in y
  "The p-value indicates that H0 should be rejected by any researcher " _n
  "who uses a significance level of " fprob(_result(3),_result(5),_result(6)) " or higher. ";
  di _n in y "It is left to you to verify that test is working properly " _n
             "in this case.";
  prompt "when ready to go on";
  di in y "Notice that testing the two hypotheses separately is not the same " _n
          "as testing them jointly.  If neither were not rejected we still " _n
          "might reject 1 and 2 simultaneously.  That H0 would like this:";
  di in b _col(10)
  "  H0:  b4 = 0 and  b6 = 0  and b7 = and b9 =0 " _n;
  prompt "when ready to test this H0":
  regress gpa age male employed ditch empdtch allnight study allstdy;
  set trace on;
  test employed empdtch allnight allstdy;
  set trace off;
  di in b
  "Notice that the p-value for the joint H0 falls between the p-values" _n
  "for the two separte H0's (1 and 2).  Do you think this will always be " _n
  "the case?" _n(2)
  "You should explore whether the conclusions of the Tests are sensitive" _n
  "to how you specify the regression.  Do the results differ if you put " _n
  "other variables in, or leave them out?  What happens if you take logs? etc. " 
  _n(3)
  "End of tutorial";
end;


