#delimit ;
cap program drop xdist;
program define xdist;
*  takes three arguments:
*   `1' = y means ask about mean
*   `2' = y means ask about variance
*   `3' = y means ask about P(X=x3|X>=x2);
version 4.0;
 local x1 = round(4*uniform(),1);
 local x2 = round(`x1'+1+(7-`x1'-1)*uniform(),1);
 local x3 = round(`x2'+1+(9-`x2'-1)*uniform(),1);
 local fx1 = round(0.1 + 0.4*uniform(),0.10);
 local fx2 = round(0.8*(1-`fx1')*uniform(),0.10);
 local fx3 = round((1-`fx1'-`fx2'),0.10);
        di in y
"Here is the density (probability) function for a random variable called X. " _n
"X takes on the three values at the top of the table with the probabilities " _n
"given inside the table"_n(2);
        xtable `x1' `x2' `x3' `fx1' `fx2' `fx3';
        local mnx = round(`x1'*`fx1' + `x2'*`fx2' + `x3'*`fx3',0.000001);
        if "`1'"=="y"  {;
           ansent `mnx' "What is E(X)?";
           xtable `x1' `x2' `x3' `fx1' `fx2' `fx3';
           };
        if "`2'"=="y" {;
           local vx = round( (`fx1')*(`x1'- `mnx')*(`x1'-`mnx')
             + (`fx2')*(`x2'-`mnx')*(`x2'-`mnx')
             + (`fx3')*(`x3'-`mnx')*(`x3'-`mnx'),0.000001);
           di in y "Given E(X) = `mnx' ";
           ansent `vx'  "What is Var(X)";
           inprompt "do you want to seen an explanation (y/n)";
           if "$junk"=="Y" | "$junk"=="y" {;
           xtable `x1' `x2' `x3' `fx1' `fx2' `fx3';
           di _col(10) in w "Var(X) =  (`fx1')*(`x1'- `mnx')*(`x1'-`mnx') " _n
              _col(10)      "          + (`fx2')*(`x2'-`mnx')*(`x2'-`mnx')" _n
              _col(10)      "          + (`fx3')*(`x3'-`mnx')*(`x3'-`mnx')" _n
              _col(10)      "       =  `vx'" _n;
           };
        };
      if "`3'"=="y" {;
         local cp = round(`fx3'/(`fx2'+`fx3'),0.000001);
         xtable `x1' `x2' `x3' `fx1' `fx2' `fx3';
         ansent `cp' "What is f(`x3'| X>= `x2')";
         inprompt "do you want to seen an explanation (y/n)";
         if "$junk"=="Y" | "$junk"=="y" {;
             xtable `x1' `x2' `x3' `fx1' `fx2' `fx3';
             di _col(10) in w
             "               f(`x3')                 " _col(10) _n
             "f(`x3'|X>=`x2') = ---------    =  `cp' "  _col(10) _n
             "                f(`x2')+f(`x3')        ";
             };
         };
end;

#delimit ;
cap program drop xtable;
program define xtable;
version 4.0;
  di _col(10) in g
      "                     X             " _n _col(10)
      "          `1'          `2'          `3'  " _n _col(10)
      "        ---------------------------" _n _col(10)
      "  f(x)   `4'   |   `5'    |  `6'      " _n _col(10)
      "        ---------------------------" _n(2);
end;
