#delimit ;
capture program drop xydist;
program define xydist;
*   `1' = y means ask about densities
*    `2' = y means ask about expectations
*    `3' = y menas ask about variance and covariance;
version 4.0;
  local goon = "y";
  while "`goon'"=="y" | "`goon'"=="Y" {;
        local indep = cond(uniform()<0.5,1,0);
        if `indep' == 1 {;
             local fx1 = round(0.1 + 0.4*uniform(),0.10);
             local fx2 = round(0.8*(1-`fx1')*uniform(),0.10);
             local fx3 = round((1-`fx1'-`fx2'),0.10);
             local fy0 = round(0.1 + 0.6*uniform(),0.10);
             local fy1 = round(1-`fy0',0.10);
             local c1 = round(`fx1' * `fy0',0.01);
             local c2 = round(`fx2' * `fy0',0.01);
             local c3 = round(`fx3' * `fy0',0.01);
             local c4 = round(`fx1' * `fy1',0.01);
             local c5 = round(`fx2' * `fy1',0.01);
             local c6 = round(`fx3' * `fy1',0.01);
           };
        else {;
             local c1 = round(uniform(),0.01);
             local c2 = round((1-`c1')*uniform(),0.01);
             local c3 = round((1-`c1'-`c2')*uniform(),0.01);
             local c4 = round((1-`c1'-`c2'-`c3')*uniform(),0.01);
             local c5 = round((1-`c1'-`c2'-`c3'-`c4')*uniform(),0.01);
             local c6 = round((1-`c1'-`c2'-`c3'-`c4'-`c5'),0.01);
             local fy0 = round(`c1'+`c2'+`c3',0.01);
             local fy1 = round(1 - `fy0',0.01);
             local fx1 = round(`c1' + `c4',0.01);
             local fx2 = round(`c2' + `c5',0.01);
             local fx3 = round(1 - `fx1' - `fx2',0.01);
             };
        local fxc3 = round(`c3'/`fy0',0.000001);
        di in y "Here is the joint density (probability) function for X and Y" _n(2);
        xytable `c1' `c2' `c3' `c4' `c5' `c6';
        if "`1'"=="y" {;
           ansent `fx2' "For X, what is f(2) (marginal density)";
           xytable `c1' `c2' `c3' `c4' `c5' `c6';
           ansent `fy0'  "For Y, what is f(0) (marginal density)";
           xytable `c1' `c2' `c3' `c4' `c5' `c6';
           ansent `fxc3' "For X, what is f(3|Y=0) (conditional density)";
           xytable `c1' `c2' `c3' `c4' `c5' `c6' `fy0' `fy1' `fx1' `fx2' `fx3';
           };
        local mnx = round(1*`fx1' + 2*`fx2' + 3*`fx3',0.000001);
        local mny = round(0*`fy0' + 1*`fy1',0.000001);
        if "`2'"=="y" {;
           ansent `mnx'  "What is E(X)?";
           xytable `c1' `c2' `c3' `c4' `c5' `c6' `fy0' `fy1' `fx1' `fx2' `fx3';
           ansent `mny'  "What is E(Y)?";
           xytable `c1' `c2' `c3' `c4' `c5' `c6' `fy0' `fy1' `fx1' `fx2' `fx3';
           local vy = round( (0-`mny')^2*`fy0'+(1-`mny')^2*`fy1',0.000001);
           };
        if "`3'"=="y" {;
           di "Given E(Y) = `mny' ";
           ansent `vy'  "What is Var(Y)?";
           xytable `c1' `c2' `c3' `c4' `c5' `c6' `fy0' `fy1' `fx1' `fx2' `fx3';
           local cv = round( (`c1')*(1- `mnx')*(0-`mny')
                + (`c2')*(2-`mnx')*(0-`mny')
                + (`c3')*(3-`mnx')*(0-`mny')
                + (`c4')*(1- `mnx')*(1-`mny')
                + (`c5')*(2-`mnx')*(1-`mny')
                + (`c6')*(3-`mnx')*(1-`mny')
                ,0.000001);
           di "Given E(Y) = `mny' and E(X) = `mnx' ";
           ansent `cv' "What is Cov(X,Y)?";
           inprompt "do you want to seen an explanation (y/n)";
           if "$junk"=="Y" | "$junk"=="y" {;
              xytable `c1' `c2' `c3' `c4' `c5' `c6' `fy0' `fy1' `fx1' `fx2' `fx3';
              di _col(10) in w "Var(X|Y=0) =    (`c1')*(1- `mnx')*(0-`mny') " _n
               _col(10)      "              + (`c2')*(2-`mnx')*(0-`mny')" _n
               _col(10)      "              + (`c3')*(3-`mnx')*(0-`mny')" _n
               _col(10)      "              + (`c4')*(1- `mnx')*(1-`mny') " _n
               _col(10)      "              + (`c5')*(2-`mnx')*(1-`mny')" _n
               _col(10)      "              + (`c6')*(3-`mnx')*(1-`mny')" _n
               _col(10)      "           =  `cv'" _n;
               };
           local cmnx = round((1*`c1' + 2*`c2' + 3*`c3')/`fy0',0.000001);
           local vx = round( (`c1'/`fy0')*(1- `cmnx')*(1-`cmnx')
                     + (`c2'/`fy0')*(2-`cmnx')*(2-`cmnx')
                     + (`c3'/`fy0')*(3-`cmnx')*(3-`cmnx'),0.000001);
           xytable `c1' `c2' `c3' `c4' `c5' `c6' `fy0' `fy1' `fx1' `fx2' `fx3';
           ansent `cmnx' "What is E(X|Y=0)";
           inprompt "do you want to seen an explanation (y/n)";
           if "$junk"=="Y" | "$junk"=="y" {;
               xytable `c1' `c2' `c3' `c4' `c5' `c6' `fy0' `fy1' `fx1' `fx2' `fx3';
               di _col(10) in w "  E(X|Y=0) =  (`c1'/`fy0')*1 " _n
              _col(10)      "              + (`c2'/`fy0')*2 " _n
              _col(10)      "              + (`c3'/`fy0')*3 " _n
              _col(10)      "           =  `cmnx' " _n;
              };
           xytable `c1' `c2' `c3' `c4' `c5' `c6' `fy0' `fy1' `fx1' `fx2' `fx3';
           di _n "Given E(X|Y=0) = `cmnx' ";
           ansent `vx'  "What is Var(X|Y=0)";
           inprompt "do you want to seen an explanation (y/n)";
           if "$junk"=="Y" | "$junk"=="y" {;
              xytable `c1' `c2' `c3' `c4' `c5' `c6' `fy0' `fy1' `fx1' `fx2' `fx3';
              di _col(10) in w "Var(X|Y=0) =  (`c1'/`fy0')*(1- `cmnx')*(1-`cmnx') " _n
              _col(10)      "              + (`c2'/`fy0')*(2-`cmnx')*(2-`cmnx')" _n
              _col(10)      "              + (`c3'/`fy0')*(3-`cmnx')*(3-`cmnx')" _n
              _col(10)      "            =  `vx'" _n;
              };
           };
        xytable `c1' `c2' `c3' `c4' `c5' `c6' `fy0' `fy1' `fx1' `fx2' `fx3';
        inprompt "Are X and Y independent? (y/n)";
        if `indep' == 1 {;
           di in y "Yes they are independent.  You should confirm that " _n
              in w _col(10) "f(x,y) = f (x) * f (y) " _n
                   _col(10) "          X       Y    " _n
              in y "for all entries in the table (not accounting for rounding)";
              };
        else {;
           di in y "They are not independent, because for example, f(1,0) does not" _n
                "equal `fx1' * `fy0' ";
           };
    inprompt "Do you want another example? (y/n)";
    local goon = "$junk";
    };
end;

